//+------------------------------------------------------------------+
//|                                                     Trending.mq4 |
//|                                   Matheszabi  |
//|                                         https://www.mathesoft.ro |
//+------------------------------------------------------------------+
#property copyright "Matheszabi,(modified by bot14)"
#property link      "https://www.mathesoft.ro"
#property version   "4.00"
#property strict
//-- indicator settings:
#property indicator_chart_window
#property  indicator_buffers 11

#property  indicator_color1   clrRed             // HH line , filtered Signal
#property  indicator_color2   clrDeepSkyBlue     // LL line , filtered signal
#property  indicator_color3   clrMagenta          // HL line 
#property  indicator_color4   clrRoyalBlue       // LH line 
#property  indicator_color5   clrNONE            // Market / Trade Open - Close time
#property  indicator_color6   clrNONE            // News Bomb
#property  indicator_color7   clrOrangeRed       // HH square Quantum
#property  indicator_color8   clrDeepSkyBlue     // LL square Quantum
#property  indicator_color9   clrRed             // HH filtered fignal
#property  indicator_color10  clrDeepSkyBlue     // LL filtered signal
//-- buffers:

double ExtBufferHH[];//line
double ExtBufferLL[];//line
double ExtBufferHL[];//line
double ExtBufferLH[];//line
double ExtBufferOpenTime[]; // Market/Period open
double ExtBufferCloseTime[]; // Market / Period close
double ExtBufferNewsTime[]; // News: EUR, GBP, USD news time release
double ExtBufferHHClose[]; // Quantum signal unfiltered
double ExtBufferLLClose[]; // Quantum signal untilfered
double ExtBufferSignalHHShort[]; // Short Enter Signal
double ExtBufferSignalLLLong[]; // Long Entry Signal

//-- input:
extern int PERIOD_HL = 85; //Slow channel
extern int PERIOD_hl = 21; //Quick channel

bool ShowTextHH = false;
bool ShowTextLL = false;
bool ShowTextHL = false;
bool ShowTextLH = false;

bool ShowQuantum = true;
bool FilterByEntryPip = true;
int EntryMinPipDifference = 10;


bool ShowTradeSignals = true;

// -- helpers
int maxPeriod;
int openMinutes, closeMinutes;
int newsTimeMinutes[]; // additional array allocated, needs to be free at the end
int newsTimeMinutesSize;

double PriceToPipMultiplier = MathPow(10, Digits-1);

double lastShortEntryPrice = 0.0;
double lastLongEntryPrice = 0.0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
{
	maxPeriod = MathMax(MathMax(MathMax(PERIOD_HL, PERIOD_HL),PERIOD_hl ),PERIOD_hl) ;
	//--- indicator buffers mapping   	  
	SetIndexBuffer(0,  ExtBufferHH);
	SetIndexBuffer(1,  ExtBufferLL);
	SetIndexBuffer(2,  ExtBufferHL);
	SetIndexBuffer(3,  ExtBufferLH);
	SetIndexBuffer(4,  ExtBufferOpenTime);
	SetIndexBuffer(5,  ExtBufferCloseTime);  
	SetIndexBuffer(6,  ExtBufferNewsTime); 
	SetIndexBuffer(7,  ExtBufferHHClose); // Quantum signal unfiltered
	SetIndexBuffer(8,  ExtBufferLLClose);  // Quantum signal unfiltered
	SetIndexBuffer(9,  ExtBufferSignalHHShort); // Short Enter Signal filtered
	SetIndexBuffer(10, ExtBufferSignalLLLong);  // Long Entry Signal filtered 
	
	SetIndexStyle(0,  DRAW_LINE,  STYLE_SOLID, 1, indicator_color1); // HH line
	SetIndexStyle(1,  DRAW_LINE,  STYLE_SOLID, 1, indicator_color2); // LL line	
	SetIndexStyle(2,  DRAW_LINE,  STYLE_DOT,   1, indicator_color3); // HL line   
	SetIndexStyle(3,  DRAW_LINE,  STYLE_DOT,   1, indicator_color4); // LH line
	
	SetIndexStyle(4,  DRAW_NONE);// Open
	SetIndexStyle(5,  DRAW_NONE);// Close
	
	SetIndexStyle(6,  DRAW_NONE);
	
	SetIndexStyle(7,  DRAW_ARROW, 0,   2, indicator_color7); // HH square
	SetIndexStyle(8,  DRAW_ARROW, 0,   2, indicator_color8); // LL square
	SetIndexStyle(9,  DRAW_NONE); // Quantum signal - filtered
	SetIndexStyle(10, DRAW_NONE); // Quantum signal - filtered
	
	SetIndexDrawBegin(0, maxPeriod);
	SetIndexDrawBegin(1, maxPeriod); 
	SetIndexDrawBegin(2, maxPeriod);
	SetIndexDrawBegin(3, maxPeriod);
	
	SetIndexArrow(7, 159);// Square HH
	SetIndexArrow(8, 159);// Square LL


	return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
const int prev_calculated,
const datetime &time[],
const double &open[],
const double &high[],
const double &low[],
const double &close[],
const long &tick_volume[],
const long &volume[],
const int &spread[])
{
	//--- MT4 only saves open/high/low/close, all of Bid and only for the current chart.
	// accessing spread array will crash this code at my broker
	int i;
	int limit = rates_total - prev_calculated;
	//int curMinutes;
	int indexHH, indexLL;
	//--- check for rates total:   
	if(rates_total <= maxPeriod){
		return(0);
	}
	//--- last counted bar will be recounted
	if(prev_calculated>0)
	{
		limit++;
	}
	// the candle is at opening time
	for(i=limit-1; i>=0  && !IsStopped(); i--){
		//-- reset
		ExtBufferHH[i] = EMPTY_VALUE;
		ExtBufferLL[i] = EMPTY_VALUE;
		ExtBufferHL[i] = EMPTY_VALUE;
		ExtBufferLH[i] = EMPTY_VALUE;
		ExtBufferOpenTime[i] = EMPTY_VALUE;
		ExtBufferCloseTime[i] = EMPTY_VALUE;
		ExtBufferNewsTime[i] = EMPTY_VALUE;
		ExtBufferHHClose[i] = EMPTY_VALUE;
		ExtBufferLLClose[i] = EMPTY_VALUE;
		ExtBufferSignalHHShort[i] = EMPTY_VALUE;
		ExtBufferSignalLLLong[i] = EMPTY_VALUE;
		
		//-- calc
		indexHH = iHighest( Symbol(), Period(), MODE_HIGH, PERIOD_HL, i );
		indexLL = iLowest( Symbol(), Period(), MODE_LOW, PERIOD_HL, i );
		ExtBufferHH[i] = High[indexHH]+21*Point;//HH  line
		ExtBufferLL[i] = Low[indexLL]-21*Point; //LL line
		
		if( indexHH == i){
			if(ShowQuantum){
				ExtBufferHHClose[i] = Close[i]+22*Point; //action taken maybe on next candle opening
			}
			checkNewHH(i);// filtered signal		    
		}		
		if( indexLL == i){
			if(ShowQuantum){
				ExtBufferLLClose[i] = Close[i]-22*Point; // action taken maybe on next candle opening
			}
			checkNewLL(i);	// filtered signal		    	    
		}
		
		ExtBufferLH[i] = Low[iLowest( Symbol(), Period(), MODE_HIGH, PERIOD_hl, i )];
		ExtBufferHL[i] = High[ iHighest( Symbol(), Period(), MODE_LOW, PERIOD_hl, i )];
		}     
	//--- return value of prev_calculated for next call
	return(rates_total);
}
//+------------------------------------------------------------------+


void checkNewHH(int indexNewHH){
	bool bypassFilterByEntryPip = false;
	if(FilterByEntryPip && indexNewHH > 0){//must be a closed candle
		if(lastShortEntryPrice > 0){
			double spreadPrice = MathAbs(Bid-Ask); 
			double priceDiff = lastShortEntryPrice - Close[indexNewHH]; 
			double priceDiffPip = priceDiff * PriceToPipMultiplier;	        
			// -- must be now a lower price:
			if(EntryMinPipDifference >= 0 && priceDiffPip < 0 && -priceDiffPip >= EntryMinPipDifference){  
				bypassFilterByEntryPip = true;;
			}
		}
		else{
			bypassFilterByEntryPip = true;;
		}
		if(bypassFilterByEntryPip){
			// short it:
			lastShortEntryPrice = Close[indexNewHH];// the new candle Open price
			if(ShowTradeSignals){
				ExtBufferSignalHHShort[indexNewHH] = lastShortEntryPrice;
			}
			lastLongEntryPrice = 0;
		}
	}
}

void checkNewLL(int indexNewLL){
	bool bypassFilterByEntryPip = false;
	if(FilterByEntryPip && indexNewLL > 0){//must be a closed candle
		if(lastLongEntryPrice > 0){
			double spreadPrice = MathAbs(Bid-Ask); 
			double priceDiff = lastLongEntryPrice - Close[indexNewLL]; 
			double priceDiffPip = priceDiff * PriceToPipMultiplier;	        
			// -- must be now a lower price:
			if(EntryMinPipDifference >= 0 && priceDiffPip > 0 && priceDiffPip >= EntryMinPipDifference){  
				bypassFilterByEntryPip = true;  
			}
		}
		else{
			bypassFilterByEntryPip = true;;
		}	    
		if(
				(!FilterByEntryPip || (FilterByEntryPip &&bypassFilterByEntryPip) )
				){
			// long it:
			lastLongEntryPrice = Close[indexNewLL];// the new candle Open price
			if(ShowTradeSignals){
				ExtBufferSignalLLLong[indexNewLL] = lastLongEntryPrice;
			}
			lastShortEntryPrice = 0;
		}
	} 
}

